/************************************************************************
**
** @(#)chkflt.h		08/05/94		Chris Ahlstrom
**
**		Manages the CheckListDialog for the DOS version.  Similar in
** some ways to the x_calpk.cpp/h/men modules.  See them for further
** commentary.
**
*************************************************************************/

#ifndef CHKFLT_h									// { CHKFLT_h
#define CHKFLT_h

#include "chklist.h"		// CheckListBase class


/************************************************************************
** CheckListFloat
**
**		Since we need to get down and dirty and modify the dialog box
** on the fly (run-time), rather than use the FACE_WIN library tools,
** we build the dialog the old-fashioned OWL 1.0 way.
**
**		To support changes to the dialog controls, we must override
** SetupWindow(). In addition, we keep track of the device list
** and the state of activity (enabled/disabled) of the radio-buttons.
**
*************************************************************************/

class CheckListFloat : public CheckListBase
{

public:

	CheckListFloat
	(
		TDeskTop *desk,				// TurboVision desktop
		int checkoptions,			// word: desired check-list options
		const char *maintitle,		// string to use for main title
		const char *itemtitle,		// string to use for item title
		int *status,				// array word encoding status of each item
		float *items,				// pointer to array of items
		int maxitem,				// count of number of items
		int initpage = 1,			// current page in list [default = 1]
		char *optionlabel = 0		// one option label for now
	);
	virtual ~CheckListFloat();

protected:							// internal support functions, virtual

	virtual void setItemString
	(
		int item
	);
	virtual void getItemString
	(
		int item
	);

};


#endif												// } CHKFLT_h
