/************************************************************************
**
** @(#)far.h		11/22/94	Chris Ahlstrom
**
**		Defines FAR and NEAR, if not already defined.
**
**		We need this feature to allow making some menu arrays and other
** large things far.  This helps in cutting down the amount of static
** data in DGROUP, instead putting it into the FAR_DATA group, usually
** with a segment name somewhat derived from the module name.
**
**		To see what happens, first change the #define below to be
** blank.  Or put "#define FAR" before the "#include far.h" directive.
** Then recompile using
**
**				make clean
**				make -Dmap fast
**
** Then observe the size of the EXE, and examine the _DATA and FAR_DATA
** groups in the FACE_TV.MAP file.  Then change the #define back and
** make it again, and see how the executable increases in size, and
** how FAR_DATA now has a non-zero length, at the expense of _DATA.
** See face_tv.men for more discussion of FAR.
**
**		Now, Borland uses _FAR to denote objects that might be "far"
** in some memory models.  We can't use _FAR, however, because we don't
** want Borland code determining whether or not our data is to go
** into the FAR_DATA group.
**
**		You might quibble with me using FAR, as too simple a name, with
** the likelihood of a clash with other's code, or with some other
** compiler.  Well, the FACE_TV library is pretty well entrenched
** with the Borland compiler, since it uses Turbo Vision.  Should you
** want to try to port Turbo Vision to Microsoft, you can then consider
** the FAR problem just "one more thing", if it becomes an issue.
** Pfffft!
**
**		It is a far, far better thing I do now, than I have ever done
** before.  Pfffft, thunk!
**
*************************************************************************/

#if !defined(FAR)											/* { FAR	*/

#define FAR		far
#define NEAR	near

#endif														/* } FAR	*/
