/************************************************************************
**
** @(#)mkbutton.cpp		10/01/95		Chris Ahlstrom
**
** Edit with tab-stops at 4.
**
**		Creates the desired kind of button device.
**
*************************************************************************/

#define MKBUTTON_cpp

#include "mkbutton.h"		// makeResponseButton() & ResponseButton class
#include "korbutt.h"		// KoalaResponseButton class
#include "msrbutt.h"		// MouseResponseButton class
#include "msptbutt.h"		// MousePointResponseButton class



ResponseButton *
makeResponseButton
(
	ResponseType buttontype
)
{
	ResponseButton *button;

	switch (buttontype)
	{
	case MOUSE_RESPONSE:
	case ALT_MOUSE_RESPONSE:
	case MOUSE_POINT_RESPONSE:
	case ALT_MOUSE_POINT_RESPONSE:

		button = new MouseResponseButton(buttontype);
		break;

	case KEYBOARD_RESPONSE:

		button = new ResponseButton(buttontype);
		break;

	case KOALA_RESPONSE:

		button = new KoalaResponseButton();
		break;

//	case MOUSE_POINT_RESPONSE:
//	case ALT_MOUSE_POINT_RESPONSE:
//
//		button = new MousePointResponseButton(buttontype);
//		break;

	default:						// unsupported ResponseButton devices

		button = 0;
		break;
	}
	return button;
}

