/************************************************************************
**
** @(#)msrbutt.h		11/23/94		Chris Ahlstrom
**
**		This module interfaces C++ with code for handling the mouse as a
** button device.
**
*************************************************************************/

#if !defined(MSRBUTT_h)									// { MSRBUTT_h
#define MSRBUTT_h

#include "rbuttons.h"		// ResponseButton class and type declarations


/************************************************************************
** MouseResponseButton base class
*************************************************************************/

class MouseResponseButton : public ResponseButton
{

public:

	MouseResponseButton				// constructor
	(
		ResponseType buttontype		// MOUSE_RESPONSE, ALT_MOUSE_RESPONSE
	);

	virtual ~MouseResponseButton();	// destructor
	virtual int readKey ();			// default support is keyboard
	virtual int waitKey ();			// special way to wait
	virtual int readCoordinates		// getting mouse coordinates, override
	(
		int &xvalue,
		int &yvalue
	);

protected:

	int setPort						// selects which mouse to use
	(
			int port				// 1==main, 2==alternate
	);
	void dawdle						// waits for buttons to be released
	(
		int button
	);

protected:

	int twoButtonsProhibited;		// for special occasions

};


#endif														// } MSRBUTT_h

