/************************************************************************
**
** @(#)rbox_bgi.h		11/14/94		Chris Ahlstrom
**
** ---------------------------
**  73340.26@compuserve.com
** ---------------------------
**
**	C++; edit with tab-stops = 4.
**
**		Defines the ResponseBGIInterior class.
**
*************************************************************************/

#if !defined(RBOX_BGI_h)								// { RBOX_BGI_h
#define RBOX_BGI_h


#include "bgibase.h"		// BGIManager class
#include "rbox_int.h"		// ResponseBoxInterior class


/************************************************************************
** ResponseBGIInterior
**
**		Since a ResponseBox is allocated in the constructor, we really
** need to add an assignment operator and copy constructor. Later...
** (famous last word).  Or make them private.
**
**		This ResponseBoxInterior has to do much real work.
**
*************************************************************************/

class ResponseBGIInterior : public ResponseBoxInterior
{

public:

	ResponseBGIInterior					// constructor
	(
		ResponseBoxLight resplightparameters[],
		int resplightcount,
		ResponseBoxText resptextparameters[],
		int resptextcount,
		unsigned *bmasklist,
		int alllightcount,
		const Rectangle &bounds,		// size of the "window"
		const char *atitle,				// optional title
		ScreenCombo combo
	);

	virtual ~ResponseBGIInterior ();	// destructor

	virtual int drawThis ();			// override

public:									// pure virtual functions

	virtual int drawSpecial				// redraw special light
	(
		int lightnumber,
		unsigned onstate
	);
	virtual int drawText
	(
		unsigned lpboffset,
		unsigned onstate
	);
	virtual int drawGraphic
	(
		unsigned lpboffset,
		unsigned onstate
	);

protected:

	void boxAspectConvert				// convert all interior lights
	(
		const Rectangle &wbox,			// window box to hold it all
		const char *atitle				// optional title
	);
	void makeLightOn					// actually draws the light on
	(
		int lightnumber
	);
	void makeLightOff					// actually draws the light off
	(
		int lightnumber
	);

protected:

	ResponseBoxLight *graphBox;			// light-layout in "virtual" units
	ResponseBoxLight *finalBox;			// light-layout in final units

	ResponseBoxText *graphTextBox;		// text-layout in "virtual" units
	ResponseBoxText *finalTextBox;		// text-layout in final units

	BGIManager *bgiControl;				// for video control

};


#endif													// } RBOX_BGI_h
