//***********************************************************************
//
// @(#)rbox_nul.h		12/30/95		Chris Ahlstrom
//
// ---------------------------
//  73340.26@compuserve.com
// ---------------------------
//
//	C++; edit this module with tab-stops of 4.
//
//		This module supports generic response-box devices.  It should
// supercede the ResponseDevice class, which was very restrictive.
// The modules to supercede are:
//
//		RBUTTONS
//		RESPWIND
//
//		The model for a ResponseBoxNull is pretty simple.  We have
// manipulator functions that call functions for the response-button
// and response-light-drawing classes that ResponseBoxNull
// uses in a "has-a" relationship.
//
//***********************************************************************

#if !defined(rbox_nul_h)								// { rbox_nul_h
#define rbox_nul_h


#include "rbox_bas.h"		// ResponseBoxDeviceBase


//***********************************************************************
// ResponseBoxNull
//
//		We override the version of startScreen, in
// in order to provide the extra function of waiting for the user.
//
//		We add a responseFeedback() routine to wait for a key press
// and show the feedback lights.
//
//***********************************************************************

class ResponseBoxNull : public ResponseBoxDeviceBase
{

public:

	ResponseBoxNull
	(
		const Rectangle &bounds,
		const char *atitle
	);

	virtual ~ResponseBoxNull();

	virtual ResponseBoxSet startScreen (int proceed = 0);
	virtual int responseFeedback (int stimulus);

	virtual void intervalLight (unsigned interval)	// disabled
	{
	}
	virtual int keyAbort ()
	{
		return 0;									// disable aborting
	}

};


#endif													// } rbox_nul_h
