/************************************************************************
**
** @(#)screnmsg.h		11/28/94		Chris Ahlstrom
**
**		An interface between C and C++ (in the guise of Turbo Vision).
**
*************************************************************************/

#ifndef SCRENMSG_h									/* { SCRENMSG_h		*/
#define SCRENMSG_h


/************************************************************************
** C/C++ screenmsg() function
**
**		This header file supports two versions of the same function...
** a name-mangled C++ version, and a non-name mangled C version.
** Since the selection must be made at compile and link time,
** we must define this function as a macro.
**
**		Primitive C callers will not need to know of the existence and
** usage of Turbo Vision. I swear it.
**
** Format:
**
**  int screenmsg(a, b, c);
**
**  (a) int use_io					Whether to ignore output
**  (b) void *handle				Bogus for now
**  (c) char *string				String to display
**
**		This macro is defined in either tvscreen.h or cnscreen.h.
**
** Define USE_TURBO_VISION, or don't define USE_CONSOLE, to use the
** Turbo Vision version of code.
**
*************************************************************************/

#ifdef USE_TURBO_VISION

#define USE_TV_VERSION	1

#else

#ifdef USE_CONSOLE
#define USE_TV_VERSION	0
#else
#define USE_TV_VERSION	1
#endif

#endif

#if USE_TV_VERSION								/* { USE_TV_VERSION		*/

	#include "tvscreen.h"						/* Turbo Vision support	*/

#else											/* }{ USE_TV_VERSION	*/

	#include "cnscreen.h"						/* console i/o support	*/

#endif											/* } USE_TV_VERSION		*/


#endif												/* } SCRENMSG_h		*/
