/************************************************************************
**
** @(#)tmouse.h		12/08/94	Chris Ahlstrom
**
**		Mouse routines for local usage, to supplement Turbo Vision.
**
*************************************************************************/

#if !defined(TMOUSE_h)									/* { TMOUSE_h	*/
#define TMOUSE_h


/************************************************************************
** Return codes for mouseButtonCheck()
*************************************************************************/

#define NO_MOUSEBUTTON			0x00
#define LEFT_MOUSEBUTTON		0x01
#define RIGHT_MOUSEBUTTON		0x02
#define BOTH_MOUSEBUTTONS		0x03
#define CENTER_MOUSEBUTTON		0x04

#define MOUSE_CHAR_WIDTH		 8
#define MOUSE_CHAR_HEIGHT		 8			/* text-mode dependent		*/


/************************************************************************
** Partial implementation of mouse BIOS functions
**
**		I copped these routines from the MSMOUSE library and tailored
** it to FACE_TV's limited usage.
**
*************************************************************************/

extern int mouseReset (void);				/* INT 33h, Func. 00h		*/
extern void mouseShowCursor (void);			/* INT 33h, Func. 01h		*/
extern void mouseHideCursor (void);			/* INT 33h, Func. 02h		*/
extern int readMouseButtons (void);			/* INT 33h, Func. 03h		*/
extern int readMouse						/* INT 33h, Func. 03h		*/
(
	int *x,
	int *y
);
extern void setMousePosition				/* INT 33h, Func. 04h		*/
(
	int x,
	int y
);
extern void setMousePixel					/* INT 33h, Func. 04h		*/
(
	int x,
	int y
);
extern int mousePresses						/* INT 33h, Func. 05h		*/
(
 /*	int bs, */					/* button selection						*/
	int *ix,					/* x coordinate of last button press	*/
	int *iy						/* y coordinate of last button press	*/
);
extern int readYmickey (void);				/* INT 33h, Func. 0Bh		*/


/************************************************************************
** monoMouseCursor() and mainMouseCursor() are defined in tmtomono.asm.
*************************************************************************/

extern void monoMouseCursor					/* ASM code, doesn't work	*/
(
	int page					/* put cursor on page 0 or 1			*/
);
extern void mainMouseCursor (void);			/* ASM code, doesn't work	*/


#ifdef USE_THIS STUFF

extern int mouseReleases					/* INT 33h, Func. 06h		*/
(
	int bs,						/* button selection						*/
	int *ix,					/* x coordinate of last button press	*/
	int *iy						/* y coordinate of last button press	*/
);
extern void mouseRegion						/* INT 33h, Func. 07h & 08h	*/
(
	int hmin,
	int hmax,
	int vmin,
	int vmax
);
extern void mouseCursor						/* INT 33h, Func. 01h		*/
(
	int *graphics				/* what the HELL is this?				*/
);

#endif


#endif													/* } TMOUSE_h	*/
