/************************************************************************
**
** @(#)ttermext.cpp		10/03/94		Chris Ahlstrom
**
** Borland C++/Turbo Vision
**
**		An extended version Turbo Vision's TTerminal class, for writing
** the screen interior to a file.
**
*************************************************************************/

#include "ttermext.h"			// TTerminalExtended class


/************************************************************************
** TTerminalExtended constructor
*************************************************************************/

TTerminalExtended::TTerminalExtended
(
	const TRect &bounds,
	TScrollBar *ahscrollbar,
	TScrollBar *avscrollbar,
	ushort bufsize
) :
	TTerminal2(bounds, ahscrollbar, avscrollbar, bufsize)
{
}


/************************************************************************
** TTerminalExtended destructor
**
**		Cannot be defined, because then TTerminal's non-virtual
** destructor will not be called.
**
*************************************************************************/


/************************************************************************
** writeBuffer()
**
**		Writes the buffer to an already-open file.
**
*************************************************************************/

ushort
TTerminalExtended::writeBuffer
(
	FILE *handle
)
{
	ushort position = queBack;
	ushort count = 0;

	if (!queEmpty())
	{
		do
		{
			if (fputc((int) buffer[position], handle) == EOF)
				break;

			count++;
			if (count > bufSize)				// play it safe
				break;
			bufInc(position);

		} while ((position != queFront) && position != queBack);
	}
    return count;
}


/************************************************************************
** killBuffer()
**
**		If the caller desires, this command will empty the buffer
** and redraw.
**
**		We must have TView::draw().  Just having nothing, or the
** overridden draw(), causes a little garbage in the window.  I'm not
** sure why.
**
*************************************************************************/

void
TTerminalExtended::killBuffer ()
{
	queFront = queBack = 0;

    setLimit(0, 1);
	TView::draw();				// doesn't clear the view, but redraws it
}
