/************************************************************************
**
** @(#)tterminl.cpp		10/07/94	Chris Ahlstrom
**
**		Identical to Borland's Turbo Vision file textview.cpp,
** but I'm trying to fix a bad bug.  "2" is appended to the names of
** the classes.  I've also added some safety checks.
**
**		TTerminal2 and TTextDevice2 member functions.
**
*************************************************************************/

#include "tterminl.h"

#if !defined(__STRING_H)
#include <string.h>
#endif


/************************************************************************
** TTextDevice2 functions
*************************************************************************/

TTextDevice2::TTextDevice2
(
	const TRect &bounds,
	TScrollBar *ahscrollbar,
	TScrollBar *avscrollbar
) :
	TScroller(bounds, ahscrollbar, avscrollbar)
{
}


int
TTextDevice2::overflow
(
	int c
)
{
	if (c != EOF)
	{
		char b = c;
		do_sputn(&b, 1);
	}
	return 1;
}


/************************************************************************
** TTerminal2 functions
*************************************************************************/

TTerminal2::TTerminal2
(
	const TRect& bounds,
	TScrollBar *ahscrollbar,
	TScrollBar *avscrollbar,
	ushort abufsize
) :
	TTextDevice2	(bounds, ahscrollbar, avscrollbar),
	bufSize			(min(32000U, abufsize)),
	buffer			(new char[bufSize]),
	queFront		(0),
	queBack			(0)
{
	growMode = gfGrowHiX + gfGrowHiY;
	setLimit(0, 1);
	setCursor(0, 0);
	showCursor();
}


TTerminal2::~TTerminal2()
{
	if (buffer)
		delete buffer;
}


void
TTerminal2::bufDec
(
	ushort &val
)
{
	if (val == 0)
		val = bufSize - 1;
	else
		val--;
}


void
TTerminal2::bufInc
(
	ushort &val
)
{
	if (++val >= bufSize)
		val = 0;
}


Boolean
TTerminal2::canInsert
(
	ushort amount
)
{
	//
	// Note the (long) cast needed so we get signed comparison.
	//

	long T = (queFront < queBack) ?
		(queFront + amount) :
		(long(queFront) - bufSize + amount) ;

	return Boolean(queBack > T);
}


void
TTerminal2::draw ()
{
	short i;
	ushort begline, endline;
	char s[256];
	ushort bottomline;

	bottomline = size.y + delta.y;
	if (limit.y > bottomline )
	{
		endline = prevLines(queFront, limit.y - bottomline);
		bufDec(endline);
	}
	else
		endline = queFront;

	if (limit.y > size.y)
		i = size.y - 1;
	else
	{
		for (i = limit.y; i <= size.y-1; i++)
			writeChar(0, i, ' ', 1, size.x);
		i = limit.y - 1;
	}

	for ( ; i >= 0; i--)
	{
		begline = prevLines(endline, 1);
		if (endline >= begline)
		{
			int t = int(endline - begline);

			memcpy(s, &buffer[begline], t);
			s[t] = EOS;
		}
		else
		{
			int t = int(bufSize - begline);

			memcpy (s, &buffer[begline], t);
			memcpy (s+t, buffer, endline);
			s[t+endline] = EOS;
		}
		if (delta.x >= strlen(s))
			*s = EOS;
		else
			strcpy(s, &s[delta.x]);

		writeStr(0, i, s, 1);
		writeChar(strlen(s), i, ' ', 1, size.x);
		endline = begline;
		bufDec( endline );
	}
}


ushort
TTerminal2::nextLine
(
	ushort pos
)
{
	if (pos != queFront)
	{
		while (buffer[pos] != '\n' && pos != queFront)
			bufInc(pos);

		if (pos != queFront)
			bufInc(pos);
	}
	return pos;
}


int
TTerminal2::do_sputn
(
	const char *s,
	int count
)
{
	if (buffer)
	{
		ushort screenLines = limit.y;

		for(ushort i = 0; i < count; i++)
			if (s[i] == '\n')
				screenLines++;

		while (!canInsert(count))
		{
			queBack = nextLine(queBack);
			screenLines--;
		}

		if ((queFront + count) >= bufSize)
		{
			i = bufSize - queFront;
			memcpy(&buffer[queFront], s, i);
			memcpy(buffer, &s[i], count - i);
			queFront = count - i;
		}
		else
		{
			memcpy(&buffer[queFront], s, count);
			queFront += count;
		}

		setLimit(limit.x, screenLines);
		scrollTo(0, screenLines + 1);

		i = prevLines(queFront, 1);
		if (i <= queFront)
			i = queFront - i;
		else
			i = bufSize - (i-queFront);

		setCursor(i, screenLines - delta.y - 1);
		drawView();
	}
	return count;
}


Boolean
TTerminal2::queEmpty ()
{
	return Boolean(queBack == queFront);
}


/************************************************************************
** otstream functions
*************************************************************************/

otstream::otstream
(
	TTerminal2 *tt
)
{
	ios::init(tt);
}

