/************************************************************************
**
** @(#)tv_pale.h		06/22/94		Chris Ahlstrom
**
** ---------------------------
**  73340.26@compuserve.com
** ---------------------------
**
**	C++
**
**	Edit using tab-stops = 4.
**
**	Turbo Vision color support
**
**		Turbo Vision handles colors as object characteristics, rather
** than as attribute bytes.   You pick "the same color as normal window
** color", rather than the attribute "yellow on blue", for example.
** The main application defines a large palette that everything
** in Turbo Vision will use.  Each object defines a short array that
** contains indices into this large palette.
**
**		The programmer uses getColor to select an index into the
** local object's palette, and the local object's palette points
** to the large palette.
**
**		We set things up so that we can select either attribute bytes
** or TV palette indices at compile-time.
**
**		Further explanation of Turbo Vision palettes:
**
**		TApplication inherits cpColor (see APP.H) from TProgram, and
** I've decided (for now) to limit the choice of colors to this palette.
** See p. 342-3 of the TV manual for a list of the colors.  At present,
** we use only colors from one section (top of p. 343).  Also, we
** use the foreground colors (using character RCELL, which fills the
** whole foreground of the cell).  We could use RBACK (which doesn't
** fill the foreground with the background color.
**
**		None of the colors in cpColor has the bright red we desire
** for the READY_LIGHT.  Instead, yellow is used, which makes it
** at least a warning in American culture.
**
*************************************************************************/

#if !defined(TV_PALE_h)								// { TV_PALE_h
#define TV_PALE_h

#define RCELL	'\xDB'					// gets foreground color
#define RBACK	' '						// gets background color

#define RESPONSE_COLOR		 9
#define INTERVAL_COLOR		10
#define READY_COLOR			11
#define ANSWER_COLOR		12
#define BACKGROUND_COLOR	13

#define RESPONSE_PAL		"\x21"		// frame-active color
#define INTERVAL_PAL		"\x21"		// frame-active color
#define READY_PAL			"\x28"		// label-shortcut color
#define ANSWER_PAL			"\x22"		// frame-icon color
#define BACK_PAL			"\x25"		// static-text color

#define OUR_EMPTY_FILL		1
#define OUR_SOLID_FILL		1


#endif												// } TV_PALE_h

